package com.magnifyb.api.cmscontrollerhome;

import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;

import org.testng.Assert;
import org.testng.annotations.Test;

import io.restassured.RestAssured;
import io.restassured.response.Response;

public class CmsControllerHome {

	private static Properties properties;

	static {
		try {
			properties = new Properties();
			String userDir = System.getProperty("user.dir");
			FileInputStream input = new FileInputStream(userDir + "/src/test/java/properties/config.properties");
			properties.load(input);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	@Test
	public void about_us() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/about_us");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void access_code() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/access_code");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void balance_sheet() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/balance_sheet");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void business_area() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/business_area");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void clearAllCaches() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/clearAllCaches");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void company_dashboard() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/company_dashboard");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void confirm_password() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/confirm_password");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void contactUs() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/contactUs");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void customer_stories() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/customer_stories");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void emailVerification() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/email-verification");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void finance_system_int() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/finance_system_int");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void footer_page() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/footer_page");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void forgot_password() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/forgot_password");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void get_chapters_count() {

		String baseUrl = properties.getProperty("base_url");
		String moduleID = properties.getProperty("moduleId");
		Response response = RestAssured.get(baseUrl + "/get_chapters_count?moduleId=" + moduleID);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void get_subchapters_count() {

		String baseUrl = properties.getProperty("base_url");
		String chapterID = properties.getProperty("chapterId");
		Response response = RestAssured.get(baseUrl + "/get_subchapters_count?chapterId=" + chapterID);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void sectors() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/get-sectors");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void home_page() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/home-page");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void how_do_compare() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/how_do_compare");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void integrate_finance() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/integrate_finance");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void landingPage() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/landingPage");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void magnifyb_video() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/magnifyb_video");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void module_master() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/module_master");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void premium_signup_form() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/premium_signup_form");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void questions() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/questions");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void read_more() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/read_more");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void session_out() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/session_out");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void signIn() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/signIn");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void signup() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/signup");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void signup_info() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/signup_info");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void task_management() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/task_management");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void terms_conditions() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/terms_conditions");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void thankyou_signup() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/thankyou_signup");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void what_if_inputs() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/what_if_inputs");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

}
