package com.magnifyb.api.commoncontroller;

import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;

import org.testng.Assert;
import org.testng.annotations.Test;

import io.restassured.RestAssured;
import io.restassured.response.Response;

public class CommonController {

	private static Properties properties;

	static {
		try {
			properties = new Properties();
			String userDir = System.getProperty("user.dir");
			FileInputStream input = new FileInputStream(userDir + "/src/test/java/properties/config.properties");
			properties.load(input);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	@Test
	public void get_dates() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/get_dates");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void get_financial_year_months() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/get_financial_year_months");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void get_pastMonths() {

		String baseUrl = properties.getProperty("base_url");
		String userID = properties.getProperty("userId");
		Response response = RestAssured.get(baseUrl + "/get_pastMonths/" + userID);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void get_pastSixMonths() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/get_pastSixMonths");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void get_presentMonths() {

		String baseUrl = properties.getProperty("base_url");
		String userID = properties.getProperty("userId");
		Response response = RestAssured.get(baseUrl + "/get_presentMonths/" + userID);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void sector_list() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/sector_list");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void today_date() {

		String baseUrl = properties.getProperty("base_url");
		Response response = RestAssured.get(baseUrl + "/today_date");
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());

		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

}
