package com.magnifyb.api.companydashboardcontroller;

import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;

import org.testng.Assert;
import org.testng.annotations.Test;

import io.restassured.RestAssured;
import io.restassured.response.Response;

public class CompanyDashboardController {

	private static Properties properties;
	Response response;

	static {
		try {
			properties = new Properties();
			String userDir = System.getProperty("user.dir");
			FileInputStream input = new FileInputStream(userDir + "/src/test/java/properties/config.properties");
			properties.load(input);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	@Test
	public void dashboard_months_balance() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		 response = RestAssured.get(baseUrl + "/dashboard_months_balance/" + username);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void dashboard_sales_annualized() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		 response = RestAssured.get(baseUrl + "/dashboard_sales_annualized/" + username);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}
	
	@Test
	public void dashboard_todays_balance() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		 response = RestAssured.get(baseUrl + "/dashboard_todays_balance/" + username);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}
	

	@Test
	public void get_actualPBT() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		 response = RestAssured.get(baseUrl + "/get_actualPBT/" + username);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}
	
	@Test
	public void get_profitBeforeTax_Ytd() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		 response = RestAssured.get(baseUrl + "/get_profitBeforeTax_Ytd_/" + username);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}
	
	@Test
	public void turnover_dashboard() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		 response = RestAssured.get(baseUrl + "/turnover_dashboard/" + username);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}
}
