package com.magnifyb.api.defaultslidercontroller;

import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;

import org.json.JSONException;
import org.json.JSONObject;
import org.testng.Assert;
import org.testng.annotations.Test;

import io.restassured.RestAssured;
import io.restassured.http.ContentType;
import io.restassured.response.Response;
import io.restassured.response.ValidatableResponse;
import io.restassured.specification.RequestSpecification;

public class DefaultSliderController {
	private static Properties properties;
	RequestSpecification requestSpecification;
	Response response;
	ValidatableResponse validatableResponse;

	static {
		try {
			properties = new Properties();
			String userDir = System.getProperty("user.dir");
			FileInputStream input = new FileInputStream(userDir + "/src/test/java/properties/config.properties");
			properties.load(input);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	@Test
	public void get_slider_values() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		 response = RestAssured.get(baseUrl + "/get_slider_values/" + username);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

	@Test
	public void saveSliderValues() throws JSONException {

		String costOfSalesLastYear = properties.getProperty("costOfSalesLastYear");
		String costOfSalesYTD = properties.getProperty("costOfSalesYTD");
		String email = properties.getProperty("email");
		String ID = properties.getProperty("id");
		String noOfMonthsLastYear = properties.getProperty("noOfMonthsLastYear");
		String noOfMonthsThisYear = properties.getProperty("noOfMonthsThisYear");
		String overheadCostsLastYear = properties.getProperty("overheadCostsLastYear");
		String overheadCostsYTD = properties.getProperty("overheadCostsYTD");
		String payrollCostLastYear = properties.getProperty("payrollCostLastYear");
		String payrollYTD = properties.getProperty("payrollYTD");
		String salesLastYear = properties.getProperty("salesLastYear");
		String salesYTD = properties.getProperty("salesYTD");

		JSONObject json = new JSONObject();
		json.put("costOfSalesLastYear", costOfSalesLastYear);
		json.put("costOfSalesYTD", costOfSalesYTD);
		json.put("email", email);
		json.put("id", ID);
		json.put("noOfMonthsLastYear", noOfMonthsLastYear);
		json.put("noOfMonthsThisYear", noOfMonthsThisYear);
		json.put("overheadCostsLastYear", overheadCostsLastYear);
		json.put("overheadCostsYTD", overheadCostsYTD);
		json.put("payrollCostLastYear", payrollCostLastYear);
		json.put("payrollYTD", payrollYTD);
		json.put("salesLastYear", salesLastYear);
		json.put("salesYTD", salesYTD);

		// Convert JSONObject to a string
		String jsonString = json.toString();

		String baseUrl = properties.getProperty("base_url");
		RestAssured.baseURI = baseUrl + "/save_slider_values";

		// Create a request specification
		requestSpecification = RestAssured.given();

		// Setting content type to specify the format in which the request payload will
		// be sent.
		requestSpecification.contentType(ContentType.JSON);

		// Adding body as a string
		requestSpecification.body(jsonString); // Use the jsonString here

		// Calling POST method
		response = requestSpecification.post();

		/*
		 * To perform validation on the response, we need to get ValidatableResponse
		 * type of response
		 */
		validatableResponse = response.then();

		// Check status code
		validatableResponse.statusCode(200);
	}

	@Test
	public void updateUser() throws JSONException {

		String costOfSalesLastYear = properties.getProperty("costOfSalesLastYear");
		String costOfSalesYTD = properties.getProperty("costOfSalesYTD");
		String email = properties.getProperty("email");
		String ID = properties.getProperty("id");
		String noOfMonthsLastYear = properties.getProperty("noOfMonthsLastYear");
		String noOfMonthsThisYear = properties.getProperty("noOfMonthsThisYear");
		String overheadCostsLastYear = properties.getProperty("overheadCostsLastYear");
		String overheadCostsYTD = properties.getProperty("overheadCostsYTD");
		String payrollCostLastYear = properties.getProperty("payrollCostLastYear");
		String payrollYTD = properties.getProperty("payrollYTD");
		String salesLastYear = properties.getProperty("salesLastYear");
		String salesYTD = properties.getProperty("salesYTD");

		JSONObject json = new JSONObject();
		json.put("costOfSalesLastYear", costOfSalesLastYear);
		json.put("costOfSalesYTD", costOfSalesYTD);
		json.put("email", email);
		json.put("id", ID);
		json.put("noOfMonthsLastYear", noOfMonthsLastYear);
		json.put("noOfMonthsThisYear", noOfMonthsThisYear);
		json.put("overheadCostsLastYear", overheadCostsLastYear);
		json.put("overheadCostsYTD", overheadCostsYTD);
		json.put("payrollCostLastYear", payrollCostLastYear);
		json.put("payrollYTD", payrollYTD);
		json.put("salesLastYear", salesLastYear);
		json.put("salesYTD", salesYTD);

		// Convert JSONObject to a string
		String jsonString = json.toString();

		String baseUrl = properties.getProperty("base_url");
		RestAssured.baseURI = baseUrl + "/update_slider_values";

		// Create a request specification
		requestSpecification = RestAssured.given();

		// Setting content type to specify format in which request payload will be sent.
		requestSpecification.contentType(ContentType.JSON);

		// Adding body as string
		requestSpecification.body(jsonString);

		// Calling PUT method
		response = requestSpecification.put();

		/*
		 * To perform validation on response, we need to get ValidatableResponse type of
		 * response
		 */
		validatableResponse = response.then();

		// Get status code
		validatableResponse.statusCode(200);

	}

}
