package com.magnifyb.api.financialdatatemplatecontroller;

import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;

import org.json.JSONException;
import org.json.JSONObject;
import org.testng.Assert;
import org.testng.annotations.Test;

import io.restassured.RestAssured;
import io.restassured.http.ContentType;
import io.restassured.response.Response;
import io.restassured.response.ValidatableResponse;
import io.restassured.specification.RequestSpecification;

public class FinancialDataTemplateController {
	private static Properties properties;
	RequestSpecification requestSpecification;
	Response response;
	ValidatableResponse validatableResponse;

	static {
		try {
			properties = new Properties();
			String userDir = System.getProperty("user.dir");
			FileInputStream input = new FileInputStream(userDir + "/src/test/java/properties/config.properties");
			properties.load(input);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	@Test
	public void balance_sheets_graph() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/balance_sheets_graph/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	@Test
	public void balancesheet_average() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/balancesheet_average/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	@Test
	public void balancesheet_daywise() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/balancesheet_daywise/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	@Test
	public void balancesheet_monthwise() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/balancesheet_monthwise/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	@Test
	public void balancesheet_view_data() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/balancesheet_view_data/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	@Test
	public void capital_reserves() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/capital_reserves/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	@Test
	public void cash_balance_month_data() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/cash_balance_month_data/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	@Test
	public void cashflow_last_five_days_data() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/cashflow_last_five_days_data/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	@Test
	public void cashflow_month_data() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/cashflow_month_data/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	@Test
	public void cashflow_month_view_data() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/cashflow_month_view_data/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	@Test
	public void cashflow_view_data() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/cashflow_view_data/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	@Test
	public void current_assests_and_liabilities() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/current_assests_and_liabilities/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	@Test
	public void DetailedPL() {
		String baseUrl = properties.getProperty("base_url");
		String email = properties.getProperty("email");
		response = RestAssured.get(baseUrl + "/DetailedPL/" + email);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	@Test
	public void get_financial_data() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/get_financial_data/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	@Test
	public void gross_margin_by_month() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/gross_margin_by_month/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	@Test
	public void grossmargin_average() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/grossmargin_average/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	@Test
	public void my_money_graph() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/my_money_graph/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	@Test
	public void PLLastYearMonthWise() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/PLLastYearMonthWise/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	@Test
	public void PLThisYearMonthWise() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/PLThisYearMonthWise/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	@Test
	public void profit_and_loss_average() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/profit_and_loss_average/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	@Test
	public void profit_and_loss_graph() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/profit_and_loss_graph/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	@Test
	public void rolling_tweleve_months() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/rolling_tweleve_months/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	@Test
	public void sales_and_revenue_graph() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/sales_and_revenue_graph/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	@Test
	public void sales_average() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/sales_average/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	@Test
	public void save_financial_data() throws JSONException {

		// balanceSheetDayWiseData
		String cashIn = properties.getProperty("cashIn");
		String cashOut = properties.getProperty("cashOut");
		String creditors = properties.getProperty("creditors");
		String debtors = properties.getProperty("debtors");
		String id = properties.getProperty("id");
		String informationFrom = properties.getProperty("informationFrom");
		String stock = properties.getProperty("stock");
		String storedDate = properties.getProperty("storedDate");
		String todaysBalance = properties.getProperty("todaysBalance");
		String username = properties.getProperty("username");

		// balanceSheetLastYearMinusOneMonthWiseEntity
		String creditorsBalanceSheet = properties.getProperty("creditorsBalanceSheet");
		String currentAssets = properties.getProperty("currentAssets");
		String currentLiabilities = properties.getProperty("currentLiabilities");
		String employees = properties.getProperty("employees");
		String fixedAssets = properties.getProperty("fixedAssets");
		String monthAndYear = properties.getProperty("monthAndYear");
		String monthEndBalance = properties.getProperty("monthEndBalance");

		// profitAndLossLastYear
		String costOfSalesLastYear = properties.getProperty("costOfSalesLastYear");
		String monthAndYearLastYear = properties.getProperty("monthAndYearLastYear");
		String payrollLastYear = properties.getProperty("payrollLastYear");
		String salesAndRevenueLastYear = properties.getProperty("salesAndRevenueLastYear");

		// profitAndLossLastYearMinusOneMonthWiseData
		String overheads = properties.getProperty("overheads");
		String payroll = properties.getProperty("payroll");
		String salesAndRevenue = properties.getProperty("salesAndRevenue");

		// profitAndLossThisYear
		String costOfSales = properties.getProperty("costOfSales");

		JSONObject json = new JSONObject();
		// balanceSheetDayWiseData
		json.put("cashIn", cashIn);
		json.put("cashOut", cashOut);
		json.put("creditors", creditors);
		json.put("debtors", debtors);
		json.put("id", id);
		json.put("informationFrom", informationFrom);
		json.put("stock", stock);
		json.put("storedDate", storedDate);
		json.put("todaysBalance", todaysBalance);
		json.put("username", username);

		// balanceSheetLastYearMinusOneMonthWiseEntity
		json.put("creditorsBalanceSheet", creditorsBalanceSheet);
		json.put("currentAssets", currentAssets);
		json.put("currentLiabilities", currentLiabilities);
		json.put("employees", employees);
		json.put("fixedAssets", fixedAssets);
		json.put("monthAndYear", monthAndYear);
		json.put("monthEndBalance", monthEndBalance);

		// profitAndLossLastYear
		json.put("costOfSalesLastYear", costOfSalesLastYear);
		json.put("monthAndYearLastYear", monthAndYearLastYear);
		json.put("payrollLastYear", payrollLastYear);
		json.put("salesAndRevenueLastYear", salesAndRevenueLastYear);

		// profitAndLossLastYearMinusOneMonthWiseData
		json.put("overheads", overheads);
		json.put("payroll", payroll);
		json.put("salesAndRevenue", salesAndRevenue);

		// profitAndLossThisYear
		json.put("costOfSales", costOfSales);

		// Convert JSONObject to a string
		String jsonString = json.toString();

		String baseUrl = properties.getProperty("base_url");
		RestAssured.baseURI = baseUrl + "/save_financial_data";

		// Create a request specification
		requestSpecification = RestAssured.given();

		// Setting content type to specify the format in which the request payload will
		// be sent.
		requestSpecification.contentType(ContentType.JSON);

		// Adding body as a string
		requestSpecification.body(jsonString); // Use the jsonString here

		// Calling POST method
		response = requestSpecification.post();

		// Print the entire response body
		System.out.println(response.body().asString());

		/*
		 * To perform validation on the response, we need to get ValidatableResponse
		 * type of response
		 */
		validatableResponse = response.then();

		// Check status code
		validatableResponse.statusCode(200);
	}

	@Test
	public void stock_debtors_creditors_by_day() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/stock_debtors_creditors_by_day/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	@Test
	public void stock_debtors_creditors_by_month() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/stock_debtors_creditors_by_month/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	@Test
	public void stock_debtors_creditors_view_data() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/stock_debtors_creditors_view_data/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	@Test
	public void today_balance() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/today_balance/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	@Test
	public void todays_balance_view_data() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/todays_balance_view_data/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

}
