package com.magnifyb.api.questionariescontroller;

import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;

import org.json.JSONException;
import org.json.JSONObject;
import org.testng.Assert;
import org.testng.annotations.Test;

import io.restassured.RestAssured;
import io.restassured.http.ContentType;
import io.restassured.response.Response;
import io.restassured.response.ValidatableResponse;
import io.restassured.specification.RequestSpecification;

public class QuestionariesController {
	private static Properties properties;
	RequestSpecification requestSpecification;
	Response response;
	ValidatableResponse validatableResponse;


	static {
		try {
			properties = new Properties();
			String userDir = System.getProperty("user.dir");
			FileInputStream input = new FileInputStream(userDir + "/src/test/java/properties/config.properties");
			properties.load(input);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	@Test
	public void get_chapter_questions_details() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		 response = RestAssured.get(baseUrl + "/get_chapter_questions_details/" + username);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}
	@Test
	public void get_chapter_wise_score() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		 response = RestAssured.get(baseUrl + "/get_chapter_wise_score/" + username);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}
	
	@Test
	public void get_generic_questions() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		 response = RestAssured.get(baseUrl + "/get_generic_questions/" + username);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}
	
	@Test
	public void get_goal_details() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		 response = RestAssured.get(baseUrl + "/get_goal_details/" + username);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}
	
	@Test
	public void get_goals_by_goal_id() {
		String baseUrl = properties.getProperty("base_url");
		String id = properties.getProperty("id");
		 response = RestAssured.get(baseUrl + "/get_goals_by_goal_id/" + id);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}
	
	@Test
	public void get_goals_by_priority() {
		String baseUrl = properties.getProperty("base_url");
		String id = properties.getProperty("id");
		 response = RestAssured.get(baseUrl + "/get_goals_by_priority/" + id);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}
	
	@Test
	public void get_goals_by_userid() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("id");
		 response = RestAssured.get(baseUrl + "/get_goals_by_userid/" + username);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}
	
	  @Test(enabled = false)
	public void get_goals_byid() {
		String baseUrl = properties.getProperty("base_url");
		String id = properties.getProperty("id");
		String status = properties.getProperty("status");
		 response = RestAssured.get(baseUrl + "/get_goals_by_userid/" + id+"/"+status);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}
	
	@Test
	public void get_notifications() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		 response = RestAssured.get(baseUrl + "/get_notifications/" + username);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}
	
	@Test
	public void get_paid_questions() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		 response = RestAssured.get(baseUrl + "/get_paid_questions/" + username);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}
	  @Test(enabled = false)
	public void get_priority_by_id() {
		String baseUrl = properties.getProperty("base_url");
		String id = properties.getProperty("id");
		String priority = properties.getProperty("priority");
		 response = RestAssured.get(baseUrl + "/get_priority_by_id/" + id+"/"+priority);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}
	
	@Test
	public void get_probility() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		 response = RestAssured.get(baseUrl + "/get_probility/" + username);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}
	
	@Test
	public void get_scoring() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		 response = RestAssured.get(baseUrl + "/get_scoring/" + username);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}
	
	@Test
	public void percentage_completion_new() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		 response = RestAssured.get(baseUrl + "/percentage_completion_new/" + username);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}
	
	@Test
	public void percentage_completion() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		 response = RestAssured.get(baseUrl + "/percentage_completion/" + username);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}
	

	@Test
	public void quiz_check() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		String chapterCode = properties.getProperty("chapterCode");
		 response = RestAssured.get(baseUrl + "/quiz_check/" + username+"/"+chapterCode);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}
	
	@Test
	public void recomended_readings() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		 response = RestAssured.get(baseUrl + "/recomended_readings/" + username);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}
	
	@Test
	public void save_chapter_questions() throws JSONException {

		String moduleCode = properties.getProperty("chapterModuleCode");
		String answerCode = properties.getProperty("chapterAnswerCode");
		String chapterCode = properties.getProperty("chaptercode");
		String chapterName = properties.getProperty("chapterName");
		String questionCode = properties.getProperty("chapterQuestionCode");
		String score = properties.getProperty("chapterScore");
		String subChapterCount = properties.getProperty("subChapterCount");
		String weightage = properties.getProperty("weightage");
		
		JSONObject json = new JSONObject();
		json.put("moduleCode", moduleCode);
		json.put("answerCode", answerCode);
		json.put("chapterCode", chapterCode);
		json.put("chapterName", chapterName);
		json.put("questionCode", questionCode);
		json.put("score", score);
		json.put("subChapterCount", subChapterCount);
		json.put("weightage", weightage);

		// Convert JSONObject to a string
		String jsonString = json.toString();

		String baseUrl = properties.getProperty("base_url");
		RestAssured.baseURI = baseUrl + "/save_chapter_questions";

		// Create a request specification
		requestSpecification = RestAssured.given();

		// Setting content type to specify the format in which the request payload will
		// be sent.
		requestSpecification.contentType(ContentType.JSON);

		// Adding body as a string
		requestSpecification.body(jsonString); // Use the jsonString here

		// Calling POST method
		response = requestSpecification.post();

		// Print the entire response body
		System.out.println(response.body().asString());

		/*
		 * To perform validation on the response, we need to get ValidatableResponse
		 * type of response
		 */
		validatableResponse = response.then();

		// Check status code
		validatableResponse.statusCode(200);
	}
	
	@Test
	public void save_generic_questionaries() throws JSONException {
	
		String moduleId = properties.getProperty("GenericmoduleId");
		String answer = properties.getProperty("GenericAnswer");
		String answerCode = properties.getProperty("GenericAnswerCode");
		String questionCode = properties.getProperty("GenericQuestionCode");
		String serialNumber = properties.getProperty("serialNumber");
		String questionId = properties.getProperty("questionId");
		String username = properties.getProperty("username");
		
		
		JSONObject json = new JSONObject();
		json.put("moduleId", moduleId);
		json.put("answer", answer);
		json.put("answerCode", answerCode);
		json.put("questionCode", questionCode);
		json.put("serialNumber", serialNumber);
		json.put("questionId", questionId);
		json.put("username", username);

		// Convert JSONObject to a string
		String jsonString = json.toString();

		String baseUrl = properties.getProperty("base_url");
		RestAssured.baseURI = baseUrl + "/save_generic_questionaries";

		// Create a request specification
		requestSpecification = RestAssured.given();

		// Setting content type to specify the format in which the request payload will
		// be sent.
		requestSpecification.contentType(ContentType.JSON);

		// Adding body as a string
		requestSpecification.body(jsonString); // Use the jsonString here

		// Calling POST method
		response = requestSpecification.post();

		// Print the entire response body
		System.out.println(response.body().asString());

		/*
		 * To perform validation on the response, we need to get ValidatableResponse
		 * type of response
		 */
		validatableResponse = response.then();

		// Check status code
		validatableResponse.statusCode(200);
	}
	
	@Test
	public void save_goals() throws JSONException {
	
		String answer = properties.getProperty("GoalAnswer");
		String cost = properties.getProperty("GoalCost");
		String date = properties.getProperty("GoalDate");
		String goal = properties.getProperty("goal");
		String goalStatus = properties.getProperty("goalStatus");
		String id = properties.getProperty("GoalID");
		String isPriority = properties.getProperty("isPriority");
		String overallCost = properties.getProperty("overallCost");
		String username = properties.getProperty("username");
		
		
		JSONObject json = new JSONObject();
		json.put("answer", answer);
		json.put("cost", cost);
		json.put("date", date);
		json.put("goal", goal);
		json.put("goalStatus", goalStatus);
		json.put("id", id);
		json.put("isPriority", isPriority);
		json.put("overallCost", overallCost);
		json.put("username", username);

		// Convert JSONObject to a string
		String jsonString = json.toString();

		String baseUrl = properties.getProperty("base_url");
		RestAssured.baseURI = baseUrl + "/save_goals";

		// Create a request specification
		requestSpecification = RestAssured.given();

		// Setting content type to specify the format in which the request payload will
		// be sent.
		requestSpecification.contentType(ContentType.JSON);

		// Adding body as a string
		requestSpecification.body(jsonString); // Use the jsonString here

		// Calling POST method
		response = requestSpecification.post();

		// Print the entire response body
		System.out.println(response.body().asString());

		/*
		 * To perform validation on the response, we need to get ValidatableResponse
		 * type of response
		 */
		validatableResponse = response.then();

		// Check status code
		validatableResponse.statusCode(200);
	}
	
	@Test
	public void save_paid_questionaries() throws JSONException {
	
		String answerId = properties.getProperty("PaidAnswerId");
		String moduleId = properties.getProperty("PaidModuleId");
		String moduleName = properties.getProperty("PaidModuleName");
		String questionId = properties.getProperty("PaidQuestionId");
		String scoring = properties.getProperty("PaidScoring");
		String username = properties.getProperty("username");
		
		
		JSONObject json = new JSONObject();
		json.put("answerId", answerId);
		json.put("moduleId", moduleId);
		json.put("moduleName", moduleName);
		json.put("questionId", questionId);
		json.put("scoring", scoring);
		json.put("username", username);

		// Convert JSONObject to a string
		String jsonString = json.toString();

		String baseUrl = properties.getProperty("base_url");
		RestAssured.baseURI = baseUrl + "/save_paid_questionaries";

		// Create a request specification
		requestSpecification = RestAssured.given();

		// Setting content type to specify the format in which the request payload will
		// be sent.
		requestSpecification.contentType(ContentType.JSON);

		// Adding body as a string
		requestSpecification.body(jsonString); // Use the jsonString here

		// Calling POST method
		response = requestSpecification.post();

		// Print the entire response body
		System.out.println(response.body().asString());

		/*
		 * To perform validation on the response, we need to get ValidatableResponse
		 * type of response
		 */
		validatableResponse = response.then();

		// Check status code
		validatableResponse.statusCode(200);
	}

	@Test
	public void save_quiz_questions() throws JSONException {

		String chapterCode = properties.getProperty("QuizChapterCode");
		String chapterName = properties.getProperty("QuizChapterName");
		String answerCode = properties.getProperty("QuizAnswerCode");
		String questionCode = properties.getProperty("QuizQuestionCode");
		String serialNumber = properties.getProperty("QuizSerialNumber");
		String subChapterCode = properties.getProperty("QuizSubChapterCode");
		String subChapterName = properties.getProperty("QuizSubChapterName");
		String value = properties.getProperty("QuizValue");
		String username = properties.getProperty("username");
		String weightage = properties.getProperty("weightage");
		
		
		JSONObject json = new JSONObject();
		json.put("chapterCode", chapterCode);
		json.put("chapterName", chapterName);
		json.put("answerCode", answerCode);
		json.put("questionCode", questionCode);
		json.put("serialNumber", serialNumber);
		json.put("subChapterCode", subChapterCode);
		json.put("subChapterName", subChapterName);
		json.put("value", value);
		json.put("username", username);
		json.put("weightage", weightage);

		// Convert JSONObject to a string
		String jsonString = json.toString();

		String baseUrl = properties.getProperty("base_url");
		RestAssured.baseURI = baseUrl + "/save_quiz_questions";

		// Create a request specification
		requestSpecification = RestAssured.given();

		// Setting content type to specify the format in which the request payload will
		// be sent.
		requestSpecification.contentType(ContentType.JSON);

		// Adding body as a string
		requestSpecification.body(jsonString); // Use the jsonString here

		// Calling POST method
		response = requestSpecification.post();

		// Print the entire response body
		System.out.println(response.body().asString());

		/*
		 * To perform validation on the response, we need to get ValidatableResponse
		 * type of response
		 */
		validatableResponse = response.then();

		// Check status code
		validatableResponse.statusCode(200);
	}
	
	@Test
	public void taskscount() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		 response = RestAssured.get(baseUrl + "/taskscount/" + username);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}
	
	@Test
	public void tm_completedList() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		 response = RestAssured.get(baseUrl + "/tm_completedList/" + username);
//		System.out.println(response.statusCode());
//		System.out.println(response.getBody().asString());
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);

	}

}
