package com.magnifyb.api.taskmanagementcontroller;

import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;

import org.json.JSONException;
import org.json.JSONObject;
import org.testng.Assert;
import org.testng.annotations.Test;

import io.restassured.RestAssured;
import io.restassured.http.ContentType;
import io.restassured.response.Response;
import io.restassured.response.ValidatableResponse;
import io.restassured.specification.RequestSpecification;

public class TaskManagementController {
	private static Properties properties;
	RequestSpecification requestSpecification;
	Response response;
	ValidatableResponse validatableResponse;

	static {
		try {
			properties = new Properties();
			String userDir = System.getProperty("user.dir");
			FileInputStream input = new FileInputStream(userDir + "/src/test/java/properties/config.properties");
			properties.load(input);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	@Test
	public void save_task_management() throws JSONException {
	

		String chapterId = properties.getProperty("TaskChapterId");
		String date = properties.getProperty("TaskDate");
		String id = properties.getProperty("TaskID");
		String moduleId = properties.getProperty("TaskModuleId");
		String subChapterId = properties.getProperty("TaskSubChapterId");
		String username = properties.getProperty("username");
		
		JSONObject json = new JSONObject();
		json.put("chapterId", chapterId);
		json.put("date", date);
		json.put("id", id);
		json.put("moduleId", moduleId);
		json.put("subChapterId", subChapterId);
		json.put("username", username);


		// Convert JSONObject to a string
		String jsonString = json.toString();

		String baseUrl = properties.getProperty("base_url");
		RestAssured.baseURI = baseUrl + "/save_task_management";

		// Create a request specification
		requestSpecification = RestAssured.given();

		// Setting content type to specify the format in which the request payload will
		// be sent.
		requestSpecification.contentType(ContentType.JSON);

		// Adding body as a string
		requestSpecification.body(jsonString); // Use the jsonString here

		// Calling POST method
		response = requestSpecification.post();

		// Print the entire response body
		System.out.println(response.body().asString());

		/*
		 * To perform validation on the response, we need to get ValidatableResponse
		 * type of response
		 */
		validatableResponse = response.then();

		// Check status code
		validatableResponse.statusCode(200);
	}
	
	@Test
	public void save_task_management_android() throws JSONException {
	

		String chapterId = properties.getProperty("TaskChapterId");
		String date = properties.getProperty("TaskDate");
		String id = properties.getProperty("TaskID");
		String moduleId = properties.getProperty("TaskModuleId");
		String subChapterId = properties.getProperty("TaskSubChapterId");
		String username = properties.getProperty("username");
		
		JSONObject json = new JSONObject();
		json.put("chapterId", chapterId);
		json.put("date", date);
		json.put("id", id);
		json.put("moduleId", moduleId);
		json.put("subChapterId", subChapterId);
		json.put("username", username);


		// Convert JSONObject to a string
		String jsonString = json.toString();

		String baseUrl = properties.getProperty("base_url");
		RestAssured.baseURI = baseUrl + "/save_task_management_android";

		// Create a request specification
		requestSpecification = RestAssured.given();

		// Setting content type to specify the format in which the request payload will
		// be sent.
		requestSpecification.contentType(ContentType.JSON);

		// Adding body as a string
		requestSpecification.body(jsonString); // Use the jsonString here

		// Calling POST method
		response = requestSpecification.post();

		// Print the entire response body
		System.out.println(response.body().asString());

		/*
		 * To perform validation on the response, we need to get ValidatableResponse
		 * type of response
		 */
		validatableResponse = response.then();

		// Check status code
		validatableResponse.statusCode(200);
	}
	
	
	@Test
	public void task_management() {
		String baseUrl = properties.getProperty("base_url");
		String username = properties.getProperty("username");
		response = RestAssured.get(baseUrl + "/task_management/" + username);
		int statusCode = response.getStatusCode();
		Assert.assertEquals(statusCode, 200);
	}

	
}
