package com.magnifyb.base;

import java.time.Duration;

import org.openqa.selenium.WebDriver;
import org.openqa.selenium.chrome.ChromeDriver;
import org.openqa.selenium.edge.EdgeDriver;
import org.openqa.selenium.firefox.FirefoxDriver;
import org.openqa.selenium.firefox.FirefoxOptions;
import org.testng.annotations.AfterTest;

import io.github.bonigarcia.wdm.WebDriverManager;

public class BaseClass {
	public static WebDriver driver;

	public static WebDriver launchBrowser(String browserType, String appURL) throws Exception {
		switch (browserType) {
		case "Chrome":
			initChromeDriver(appURL);
			break;

		case "Firefox":
			initFirefoxDriver(appURL);
			break;

		case "InternetExplorer":
			initInternetExplorer(appURL);
			break;

		default:
			System.out.println("browser : " + browserType + " is invalid");
		}
		return driver;
	}

	public static void initChromeDriver(String appURL) throws Exception {
		System.out.println("Launching google chrome with new profile..");
		WebDriverManager.chromedriver().setup();
		// Set up ChromeOptions for headless mode
//	    ChromeOptions chromeOptions = new ChromeOptions();
//	    chromeOptions.addArguments("--headless"); // Run in headless mode
		driver = new ChromeDriver();
		driver.manage().window().maximize();
		driver.get(appURL);
		driver.manage().timeouts().implicitlyWait(Duration.ofSeconds(30));
	}

	public static void initFirefoxDriver(String appURL) throws Exception {
		System.out.println("Launching Firefox browser..");
		WebDriverManager.firefoxdriver().setup();
		FirefoxOptions fo = new FirefoxOptions();
		fo.setBinary("/path/to/firefox/binary");
		driver = new FirefoxDriver(fo);
//		driver = new FirefoxDriver();
		driver.manage().window().maximize();
		driver.get(appURL);
		driver.manage().timeouts().implicitlyWait(Duration.ofSeconds(30));
	}

	public static void initInternetExplorer(String appURL) throws Exception {
		System.out.println("Launching InternetExplorer browser..");
		WebDriverManager.edgedriver().setup();
		driver = new EdgeDriver();
		driver.manage().window().maximize();
		driver.get(appURL);
		driver.manage().timeouts().implicitlyWait(Duration.ofSeconds(30));
	}

	@AfterTest
	public void Close() {
		driver.quit();
	}
}
