package com.magnifyb.restassured;

import org.testng.annotations.Test;

import io.restassured.RestAssured;
import io.restassured.http.ContentType;
import io.restassured.response.Response;
import io.restassured.response.ValidatableResponse;
import io.restassured.specification.RequestSpecification;

public class LoginPostAPI {

	@Test
	public void login() {

		String body = "{\n" + "  \"password\": \"Machint@123\",\n" + "  \"username\": \"ramanjeneyulu.j@machint.com\"\n"
				+ "}";

		// Create a request specification
		RequestSpecification request = RestAssured.given();

		request.contentType(ContentType.JSON);

		request.baseUri("https://magnifytest.machint.com/login");
		// Adding body as string
		request.body(body);

		// Calling POST method on URI. After hitting we get Response
		Response response = request.post();

		// Printing Response as string
		System.out.println(response.asString());

		// Get Validatable response to perform validation
		ValidatableResponse validatableResponse = response.then();

		// Validate status code as 200
		validatableResponse.statusCode(200);

	}
	
//	@Test
//	public void UserRegistrationSuccessful() 
//	{ 
//	    RestAssured.baseURI ="https://magnifytest.machint.com"; 
//	    RequestSpecification request = RestAssured.given(); 
//	    JSONObject requestParams = new JSONObject();
//	    requestParams.put("username", "ramanjeneyulu.j@machint.com");
//	    requestParams.put("password", "Machint@123"); 
//	    request.body(requestParams.toJSONString());
//	    Response response = request.put("/login"); 
//	    ResponseBody body = response.getBody();
//	    System.out.println(response.getStatusLine());
//	    System.out.println(body.asString());
//	     
//	}
}
