package com.magnifyb.testcases;

import org.openqa.selenium.WebDriver;
import org.testng.annotations.BeforeTest;
import org.testng.annotations.Test;

import com.magnifyb.base.BaseClass;
import com.magnifyb.webpages.BusinessAreas;
import com.magnifyb.webpages.Login;

public class BusinessAreasTestcase {

	WebDriver driver;
	Login login;
	BusinessAreas businessAreas;

	@BeforeTest
	public void setup() throws Exception {
		driver = BaseClass.launchBrowser("Chrome", "https://magnifywebtest.machint.com/");
		Thread.sleep(5000);
	}

	@Test(priority = 1)
	public void navigate_to_dashboard() throws Exception {
		login = new Login(driver);
		login.loginApplication();
	}

	@Test(priority = 2)
	public void businessareas() throws Exception {
		businessAreas = new BusinessAreas(driver);
		businessAreas.navigateBusinessAreas();
		businessAreas.navigateStartFinanceQuestionnaire();
		businessAreas.managementInformation(0, 3, 2, 3, 2, 1, 0, 3);
		businessAreas.forecasting(3, 1, 3, 2);
		businessAreas.debtorManagement(0, 1, 2, 3, 3, 3, 3, 3, 3);
		businessAreas.creditorManagement(2, 2, 2, 3, 3, 3);
		businessAreas.payroll(3, 3, 2, 2, 3);
		businessAreas.stockManagement(3, 3, 3, 3, 3);
		businessAreas.hmrc(2, 2, 2);
		businessAreas.fixedAssets(1, 1, 2, 2, 2, 3, 3);
		businessAreas.finance(1, 3, 0);
		businessAreas.businessOverview();
	}
}
