package com.magnifyb.utils;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;

import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.DataFormatter;
import org.apache.poi.xssf.usermodel.XSSFCell;
import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

public class Excel {

	public static XSSFWorkbook workbook;
	public static XSSFSheet sheet;
	public static XSSFRow row;
	public static XSSFCell cell;
	public static int i, j, rowCount, colCount, totalSheet, rCnt, cCnt;
	public static String cellValue, celldata;

	public static void readExcel(String filepath, String sheetName) throws Exception {
		File file = new File(filepath);
		FileInputStream fis = new FileInputStream(file);
		workbook = new XSSFWorkbook(fis);
		sheet = workbook.getSheet(sheetName);
	}

	public static int getRowCount() {
		rowCount = sheet.getLastRowNum();
//			System.out.println(rowCount);
		return rowCount;
	}

	public static int getColumnCount() {
		row = sheet.getRow(0);
		colCount = row.getLastCellNum();
//			System.out.println(colCount);
		return colCount;
	}

	public static String getCellContentAsString(Cell cell) throws Exception {
		switch (cell.getCellType()) {
		case Cell.CELL_TYPE_BLANK:
			celldata = "";
			break;

		case Cell.CELL_TYPE_STRING:
			celldata = cell.getStringCellValue();
			break;

		case Cell.CELL_TYPE_NUMERIC:
			DataFormatter df = new DataFormatter();
			celldata = df.formatCellValue(cell);
			break;

		case Cell.CELL_TYPE_FORMULA:
			celldata = String.valueOf(cell.getNumericCellValue());
			break;

		case Cell.CELL_TYPE_BOOLEAN:
			celldata = String.valueOf(cell.getBooleanCellValue());
			break;

		default:
			celldata = cell.getStringCellValue();
			break;
		}
		return celldata;
	}

	public static String getCellData(int colNum, int rowNum) throws Exception {
		String result = null;
		cell = sheet.getRow(rowNum).getCell(colNum);
		result = getCellContentAsString(cell);
		return result;
	}

	public static String testDataFromExcel(String columnName) throws Exception {
		for (i = 1; i <= getRowCount(); i++) {
			row = sheet.getRow(i);
			cell = row.getCell(0);
			String actionvalue = cell.getStringCellValue();
			if (actionvalue.equalsIgnoreCase(columnName)) {
				cell = sheet.getRow(i).getCell(1);
				cellValue = getCellContentAsString(cell);
			}
		}
		return cellValue;
	}

	public static void writeDataToExcel(String filepath, String sheetName, String columnName, String value)
			throws Exception {
		File myFile = new File(filepath);
		FileInputStream fis = new FileInputStream(myFile);
		XSSFWorkbook workbook = new XSSFWorkbook(fis);
		XSSFSheet sheet = workbook.getSheet(sheetName);

		for (i = 1; i <= getRowCount(); i++) {
			row = sheet.getRow(i);
			cell = row.getCell(0);
			String actionvalue = cell.getStringCellValue();
			if (actionvalue.equalsIgnoreCase(columnName)) {
				Cell textValue = sheet.getRow(i).createCell(1);
				textValue.setCellType(Cell.CELL_TYPE_STRING);
				textValue.setCellValue(value);
				FileOutputStream fos = new FileOutputStream(myFile);
				workbook.write(fos);
				fos.close();
			}

		}
	}
}
