package com.magnifyb.utils;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;

import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.DataFormatter;
import org.apache.poi.xssf.usermodel.XSSFCell;
import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

public class ExcelData {

	public static XSSFWorkbook workbook;
	public static XSSFSheet sheet;
	public static XSSFRow row;
	public static XSSFCell cell;
	public static String FilePath = System.getProperty("user.dir") + "\\src\\test\\java\\testdata\\testdata.xlsx";
	public static String SheetName = "Sheet2";
	public static String cellValue;
	public static int rowCount, colCount;

	public void setExcelFile(String excelFilePath, String sheetName) throws IOException {
		// Create an object of File class to open xlsx file
		File file = new File(excelFilePath);

		// Create an object of FileInputStream class to read excel file
		FileInputStream inputStream = new FileInputStream(file);

		// creating workbook instance that refers to .xlsx file
		workbook = new XSSFWorkbook(inputStream);

		// creating a Sheet object
		sheet = workbook.getSheet(sheetName);
	}

	// This method is to get the row count used of the excel sheet
	public static int getRowCount() {
		rowCount = sheet.getLastRowNum();
		System.out.println("last row is \t" + rowCount);
		return rowCount;
	}

	// This method is to get the column count used of the excel sheet
	public static int getColumnCount() {
		row = sheet.getRow(0);
		colCount = row.getLastCellNum();
		System.out.println("last column is \t" + colCount);
		return colCount;
	}

	// This method is to get cell types used of the excel sheet
	public static String getCellContentAsString(Cell cell) throws Exception {
		switch (cell.getCellType()) {
		case Cell.CELL_TYPE_BLANK:
			cellValue = "";
			break;

		case Cell.CELL_TYPE_STRING:
			cellValue = cell.getStringCellValue();
			break;

		case Cell.CELL_TYPE_NUMERIC:
			DataFormatter df = new DataFormatter();
			cellValue = df.formatCellValue(cell);
			break;

		case Cell.CELL_TYPE_FORMULA:
			cellValue = String.valueOf(cell.getNumericCellValue());
			break;

		case Cell.CELL_TYPE_BOOLEAN:
			cellValue = String.valueOf(cell.getBooleanCellValue());
			break;

		default:
			cellValue = cell.getStringCellValue();
			break;
		}
		return cellValue;
	}

	public static String getCellData(int RowNum, int ColNum) {
		cell = sheet.getRow(RowNum).getCell(ColNum);
		DataFormatter formatter = new DataFormatter();
		return formatter.formatCellValue(cell);
	}

	public int getNoOfRows() {
		return sheet.getPhysicalNumberOfRows();
	}

	public int getNoOfColumns() {
		return sheet.getRow(0).getLastCellNum();
	}

	public Object[][] to2DArray() throws Exception {
		int noOfRows = getNoOfRows() - 1;
		int noOfCells = getNoOfColumns();
		Object obj[][] = new Object[noOfRows][noOfCells];

		for (int i = 0; i < noOfRows; i++) { // i = 0 1 2
			// row = sh.getRow(i);
			for (int j = 0; j < noOfCells; j++) {
				obj[i][j] = getCellData(i + 1, j); // i = 1 2 3
			}
		}
		return obj;
	}
}
