package com.magnifyb.webpages;

import java.time.Duration;

import org.openqa.selenium.By;
import org.openqa.selenium.Keys;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.support.ui.ExpectedConditions;
import org.openqa.selenium.support.ui.WebDriverWait;

public class AccessCode {

	private static WebDriver driver;

	By accessCodeClickHere = By.xpath("//span[text()='CLICK HERE.']");
	By firstname = By.name("firstName");
	By lastname = By.name("lastName");
	By businessname = By.name("businessName");
	By email = By.name("email");
	By mobile = By.name("mobile");
	By termsAndConditions = By.xpath("//label//input[@name='termsAndConditions']//following::span[1]");
	By termsAndConditions2 = By.xpath("//label//input[@name='termsAndConditions2']//following::span[1]");
	By submitButton = By.xpath("//div[text()='Submit']");

	By emailiD = By.xpath("//input[@type='email']");
	By nextButton = By.xpath("//span[contains(text(),'Next')]");
	By password = By.xpath("//input[@type='password']");
	By searchSubjectText = By.xpath("//input[@placeholder='Search in mail']");
	By clickonEmail = By.xpath("(//div[@class='nH ar4 B']//div[@class='Nr UI S2 vy'])[2]//table//tr[1]/td[@role='gridcell'][1]");
	By mailList = By.xpath("(//div[@role='listitem'])[last()]");
	By showButton = By.xpath("(//div[@aria-label='Show trimmed content'])[last()]");

	public AccessCode(WebDriver driver) {
		AccessCode.driver = driver;
	}

	public void generateAccessCode() throws Exception {
		WebElement accesscodeClickHere = driver.findElement(accessCodeClickHere);
		accesscodeClickHere.click();

		WebElement firstName = driver.findElement(firstname);
		firstName.sendKeys("Durga");

		WebElement lastName = driver.findElement(lastname);
		lastName.sendKeys("P");

		WebElement businessName = driver.findElement(businessname);
		businessName.sendKeys("Machint");

		WebElement emailID = driver.findElement(email);
		emailID.sendKeys("durga.ponnana@machint.com");

		WebElement mobileNumber = driver.findElement(mobile);
		mobileNumber.sendKeys("06789678989");

		WebElement termsAndconditions = driver.findElement(termsAndConditions);
		termsAndconditions.click();

		WebElement termsAndconditions2 = driver.findElement(termsAndConditions2);
		termsAndconditions2.click();

		WebElement submitbutton = driver.findElement(submitButton);
		submitbutton.click();
	}

	public void getAccessCode() throws Exception {
		driver.get("https://mail.google.com/mail/u/0/#inbox");

		WebElement email_ID = driver.findElement(emailiD);
		email_ID.sendKeys("durga.ponnana@machint.com");

		WebDriverWait wait = new WebDriverWait(driver, Duration.ofSeconds(30));

		WebElement nextbutton = wait.until(ExpectedConditions.elementToBeClickable(nextButton));
		nextbutton.click();
		Thread.sleep(5000);

		WebElement password1 = driver.findElement(password);
		password1.sendKeys("ponnana@137");

		Thread.sleep(5000);

		WebElement nextbutton1 = wait.until(ExpectedConditions.elementToBeClickable(nextButton));
		nextbutton1.click();

		Thread.sleep(10000);

		WebElement searchsubjectText = wait.until(ExpectedConditions.presenceOfElementLocated(searchSubjectText));
		searchsubjectText.sendKeys("Access Code");
		searchsubjectText.sendKeys(Keys.ENTER);
		Thread.sleep(2000);

		WebElement clickonemail = driver.findElement(clickonEmail);
		clickonemail.click();

		WebElement maillist = driver.findElement(mailList);
		maillist.click();

		try {
			WebElement showbutton = driver.findElement(showButton);
			showbutton.click();
		} catch (Exception e) {
			// TODO: handle exception
		}

	}

}
