package com.magnifyb.webpages;

import java.time.Duration;

import org.openqa.selenium.By;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.interactions.Actions;
import org.openqa.selenium.support.ui.ExpectedConditions;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.testng.Assert;

public class BusinessAreas {

	private static WebDriver driver;
	int[] optionValues = { 1, 3, 7, 10 };
	int managementInfromationChapter, forecastingChapter, debtorManagementChapter, creditorManagementChapter,
			payrollChapter, stockManagementChapter, hmrcChapter, fixedAssetsChapter, financeChapter;

	int managementInformationValue, forecastingValue, debtorManagementValue, creditorManagementValue, payrollValue,
			stockManagementValue, hmrcValue, fixedAssetsValue, financeValue;

	// Click on Business Areas
	By businessAreas = By.xpath("(//*[local-name()='svg'])[4]");
	By finance = By.xpath("(//span[text()='Finance']//following::*[local-name()='svg'])[1]");
	By startFinanceQuestionnaire = By.xpath("//div[text()='Start Finance Questionnaire']");
	By financeText = By.xpath("//div[text()='Finance']");
	By managementInformationText = By.xpath("//div[text()='Management Information']");
	By nextButton = By.xpath("//div[text()='Next']");
	By forecastingText = By.xpath("//div[text()='Forecasting P&L and cashflow']");
	By debtorManagementText = By.xpath("//div[text()='Debtor Management']");
	By creditorManagementText = By.xpath("//div[text()='Creditor Management']");
	By payrollText = By.xpath("//div[text()='Payroll / HR /Staff Management']");
	By stockManagementText = By.xpath("//div[text()='Stock Management']");
	By hmrcText = By.xpath("//div[text()='HMRC - Payments']");
	By fixedAssetsText = By.xpath("//div[text()='Fixed Assets / Capital Expenditure']");
	By submitButton = By.xpath("//div[text()='Submit']");

	By managementInformationScore = By.xpath("(//*[local-name()='text'])[1]");
	By forecastingScore = By.xpath("(//*[local-name()='text'])[2]");
	By debtorManagementScore = By.xpath("(//*[local-name()='text'])[3]");
	By creditorManagementScore = By.xpath("(//*[local-name()='text'])[4]");
	By payrollScore = By.xpath("(//*[local-name()='text'])[5]");
	By stockManagementScore = By.xpath("(//*[local-name()='text'])[6]");
	By hmrcScore = By.xpath("(//*[local-name()='text'])[7]");
	By fixedAssetsScore = By.xpath("(//*[local-name()='text'])[8]");
	By financeScore = By.xpath("(//*[local-name()='text'])[9]");
	By overallPercentageScore = By.xpath("(//*[local-name()='text'])[10]");

	public BusinessAreas(WebDriver driver) {
		BusinessAreas.driver = driver;
	}

	public void navigateBusinessAreas() throws Exception {
		WebElement businessareas = driver.findElement(businessAreas);
		WebDriverWait wait = new WebDriverWait(driver, Duration.ofSeconds(30));
		wait.until(ExpectedConditions.elementToBeClickable(businessareas));
		businessareas.click();
	}

	public void navigateStartFinanceQuestionnaire() throws Exception {
		WebElement financeButton = driver.findElement(finance);
		financeButton.click();

		Thread.sleep(3000);

		WebElement startfinanceQuestionnaire = driver.findElement(startFinanceQuestionnaire);
		startfinanceQuestionnaire.click();
		Thread.sleep(3000);

		WebElement financetext = driver.findElement(financeText);
		Assert.assertEquals(financetext.getText(), "Finance");
	}

	public void managementInformation(int question1Index, int question2Index, int question3Index, int question4Index,
			int question5Index, int question6Index, int question7Index, int question8Index) throws Exception {
		WebElement managementInformation = driver.findElement(managementInformationText);
		Assert.assertEquals(managementInformation.getText(), "Management Information");

		// How often do you prepare Management Accounts
		WebElement question1 = driver.findElement(
				By.xpath("//div[text()='How often do you prepare Management Accounts']//following::div[2]/div/div["
						+ (question1Index + 1) + "]"));
		question1.click();
		Thread.sleep(2000);

		String[] question1_Options = { "Never", "Annually", "Quarterly", "Monthly" };

		int MI_01 = 0;

		if (question1Index >= 0 && question1Index < question1_Options.length) {
			MI_01 = optionValues[question1Index];
		}

		System.out.println("MI_01 value: " + MI_01);

		// Do your Management Accounts' Profit figures agree with those in your Year End
		// Accounts?
		WebElement question2 = driver.findElement(By.xpath(
				"//div[text()=\"Do your Management Accounts' Profit figures agree with those in your Year End Accounts?\"]//following::div[2]/div/div["
						+ (question2Index + 1) + "]"));
		question2.click();
		Thread.sleep(2000);

		String[] question2_Options = { "Don't know", "Over 15% variance", "Within 15% variance", "Within 5% variance" };

		int MI_02 = 0;

		if (question2Index >= 0 && question2Index < question2_Options.length) {
			MI_02 = optionValues[question2Index];
		}

		System.out.println("MI_02 value: " + MI_02);

		// Do you prepare a Budget
		WebElement question3 = driver.findElement(By.xpath(
				"//div[text()='Do you prepare a Budget']//following::div[2]/div/div[" + (question3Index + 1) + "]"));
		question3.click();
		Thread.sleep(2000);

		String[] question3_Options = { "Never", "Annually", "Quarterly Detailed", "Monthly detailed" };

		int MI_03 = 0;

		if (question3Index >= 0 && question3Index < question3_Options.length) {
			MI_03 = optionValues[question3Index];
		}

		System.out.println("MI_03 value: " + MI_03);

		// Do you have Actuals compared to Budget with a Variance
		WebElement question4 = driver.findElement(By.xpath(
				"//div[text()='Do you have Actuals compared to Budget with a Variance']//following::div[2]/div/div["
						+ (question4Index + 1) + "]"));
		question4.click();
		Thread.sleep(2000);

		String[] question4_Options = { "Never", "Annually", "Quarterly With Variance analysis",
				"Monthly With Variance analysis" };

		int MI_04 = 0;

		if (question4Index >= 0 && question4Index < question4_Options.length) {
			MI_04 = optionValues[question4Index];
		}

		System.out.println("MI_04 value: " + MI_04);

		Actions action = new Actions(driver);
		WebElement nextbutton = driver.findElement(nextButton);
		action.moveToElement(nextbutton).build().perform();

		// Do you have an accurate analysis of Gross margin by product?
		WebElement question5 = driver.findElement(By.xpath(
				"//div[text()='Do you have an accurate analysis of Gross margin by product?']//following::div[2]/div/div["
						+ (question5Index + 1) + "]"));
		question5.click();
		Thread.sleep(2000);

		String[] question5_Options = { "none", "Some products", "Top 80% of products", "All Products" };

		int MI_05 = 0;

		if (question5Index >= 0 && question5Index < question5_Options.length) {
			MI_05 = optionValues[question5Index];
		}

		System.out.println("MI_05 value: " + MI_05);

		// Do you have an accurate analysis of sales by Customer?
		WebElement question6 = driver.findElement(By.xpath(
				"//div[text()='Do you have an accurate analysis of sales by Customer?']//following::div[2]/div/div["
						+ (question6Index + 1) + "]"));
		question6.click();
		Thread.sleep(2000);

		String[] question6_Options = { "none", "Some products", "Top 10 Customers", "All Customers" };

		int MI_06 = 0;

		if (question6Index >= 0 && question6Index < question6_Options.length) {
			MI_06 = optionValues[question6Index];
		}

		System.out.println("MI_06 value: " + MI_06);

		// Do you have an accurate analysis of gross Margin by Customer?
		WebElement question7 = driver.findElement(By.xpath(
				"//div[text()='Do you have an accurate analysis of gross Margin by Customer?']//following::div[2]/div/div["
						+ (question7Index + 1) + "]"));
		question7.click();
		Thread.sleep(2000);

		String[] question7_Options = { "none", "Some products", "Top 10 Customers", "All Customers" };

		int MI_07 = 0;

		if (question7Index >= 0 && question7Index < question7_Options.length) {
			MI_07 = optionValues[question7Index];
		}

		System.out.println("MI_07 value: " + MI_07);

		// How often do you review costs & look for savings?
		WebElement question8 = driver.findElement(
				By.xpath("//div[text()='How often do you review costs & look for savings?']//following::div[2]/div/div["
						+ (question8Index + 1) + "]"));
		question8.click();
		Thread.sleep(2000);

		String[] question8_Options = { "When problems occur", "Quarterly", "Monthly", "Regularly" };

		int MI_08 = 0;

		if (question8Index >= 0 && question8Index < question8_Options.length) {
			MI_08 = optionValues[question8Index];
		}

		System.out.println("MI_08 value: " + MI_08);

		managementInfromationChapter = MI_01 + MI_02 + MI_03 + MI_04 + MI_05 + MI_06 + MI_07 + MI_08;
		System.out.println(managementInfromationChapter);
		managementInformationValue = (int) Math.round((double) managementInfromationChapter / 80 * 100);
		System.out.println(managementInformationValue);

		nextbutton.click();
		Thread.sleep(2000);
	}

	public void forecasting(int question1Index, int question2Index, int question3Index, int question4Index)
			throws Exception {
		WebElement foreCasting = driver.findElement(forecastingText);
		Assert.assertEquals(foreCasting.getText(), "Forecasting P&L and cashflow");

		// Do you prepare a P&L forecast looking at the F/Y year ahead
		WebElement question1 = driver.findElement(By.xpath(
				"//div[text()='Do you prepare a P&L forecast looking at the F/Y year ahead']//following::div[2]/div/div["
						+ (question1Index + 1) + "]"));
		question1.click();
		Thread.sleep(2000);

		String[] question1_Options = { "Never", "Annually", "Quarterly", "Monthly" };

		int FC_01 = 0;

		if (question1Index >= 0 && question1Index < question1_Options.length) {
			FC_01 = optionValues[question1Index];
		}

		System.out.println("FC_01 value: " + FC_01);

		// How often do you update the P&L forecast?
		WebElement question2 = driver.findElement(
				By.xpath("//div[text()='How often do you update the P&L forecast?']//following::div[2]/div/div["
						+ (question2Index + 1) + "]"));
		question2.click();
		Thread.sleep(2000);

		String[] question2_Options = { "Never", "Annually", "Quarterly", "Monthly" };

		int FC_02 = 0;

		if (question2Index >= 0 && question2Index < question2_Options.length) {
			FC_02 = optionValues[question2Index];
		}

		System.out.println("FC_02 value: " + FC_02);

		// How often do you prepare a cashflow
		WebElement question3 = driver.findElement(
				By.xpath("//div[contains(text(),'How often do you prepare a cashflow ')]//following::div[2]/div/div["
						+ (question3Index + 1) + "]"));
		question3.click();
		Thread.sleep(2000);

		String[] question3_Options = { "Never", "Annually", "Monthly", "Weekly" };

		int FC_03 = 0;

		if (question3Index >= 0 && question3Index < question3_Options.length) {
			FC_03 = optionValues[question3Index];
		}

		System.out.println("FC_03 value: " + FC_03);

		// What period does your cashflow forecast cover?
		WebElement question4 = driver.findElement(By.xpath(
				"//div[contains(text(),'What period does your cashflow forecast cover?')]//following::div[2]/div/div["
						+ (question4Index + 1) + "]"));
		question4.click();
		Thread.sleep(2000);

		String[] question4_Options = { "Never", "Annually", "Monthly", "Weekly" };

		int FC_04 = 0;

		if (question4Index >= 0 && question4Index < question4_Options.length) {
			FC_04 = optionValues[question4Index];
		}

		System.out.println("FC_04 value: " + FC_04);

		forecastingChapter = FC_01 + FC_02 + FC_03 + FC_04;
		System.out.println(forecastingChapter);
		forecastingValue = (int) Math.round((double) forecastingChapter / 40 * 100);
		System.out.println(forecastingValue);
		WebElement nextbutton = driver.findElement(nextButton);
		nextbutton.click();
		Thread.sleep(2000);
	}

	public void debtorManagement(int question1Index, int question2Index, int question3Index, int question4Index,
			int question5Index, int question6Index, int question7Index, int question8Index, int question9Index)
			throws Exception {
		WebElement debtorManagement = driver.findElement(debtorManagementText);
		Assert.assertEquals(debtorManagement.getText(), "Debtor Management");

		// Do you have robust & effective terms & conditions of Sale including payment
		// terms, proven with customers
		WebElement question1 = driver.findElement(By.xpath(
				"//div[text()='Do you have robust & effective terms & conditions of Sale including payment terms, proven with customers']//following::div[2]/div/div["
						+ (question1Index + 1) + "]"));
		question1.click();
		Thread.sleep(2000);

		String[] question1_Options = { "None", "Weak", "Suitable", "Fully proven" };

		int DM_01 = 0;

		if (question1Index >= 0 && question1Index < question1_Options.length) {
			DM_01 = optionValues[question1Index];
		}

		System.out.println("DM_01 value: " + DM_01);

		// Do you raise invoices as soon as the job / goods are delivered
		WebElement question2 = driver.findElement(By.xpath(
				"//div[text()='Do you raise invoices as soon as the job / goods are delivered']//following::div[2]/div/div["
						+ (question2Index + 1) + "]"));
		question2.click();
		Thread.sleep(2000);

		String[] question2_Options = { "Over 7 days", "Within 7 days", "Within 3 days", "Immediate" };

		int DM_02 = 0;

		if (question2Index >= 0 && question2Index < question2_Options.length) {
			DM_02 = optionValues[question2Index];
		}

		System.out.println("DM_02 value: " + DM_02);

		// How long do Customers take to pay you?
		WebElement question3 = driver.findElement(
				By.xpath("//div[text()='How long do Customers take to pay you?']//following::div[2]/div/div["
						+ (question3Index + 1) + "]"));
		question3.click();
		Thread.sleep(2000);

		String[] question3_Options = { "Over 60 days", "60 days", "45 days", "30 days or less" };

		int DM_03 = 0;

		if (question3Index >= 0 && question3Index < question3_Options.length) {
			DM_03 = optionValues[question3Index];
		}

		System.out.println("DM_03 value: " + DM_03);

		// Do you have a defined process for debtor management?
		WebElement question4 = driver.findElement(By.xpath(
				"//div[text()='Do you have a defined process for debtor management?']//following::div[2]/div/div["
						+ (question4Index + 1) + "]"));
		question4.click();
		Thread.sleep(2000);

		String[] question4_Options = { "none", "Poor processes", "Some Processes", "Good processes" };

		int DM_04 = 0;

		if (question4Index >= 0 && question4Index < question4_Options.length) {
			DM_04 = optionValues[question4Index];
		}

		System.out.println("DM_04 value: " + DM_04);

		// Does any one client represent a high% of your business?
		WebElement question5 = driver.findElement(By.xpath(
				"//div[text()='Does any one client represent a high% of your business?']//following::div[2]/div/div["
						+ (question5Index + 1) + "]"));
		question5.click();
		Thread.sleep(2000);

		String[] question5_Options = { ">40%", "<40%", "<20%", "No" };

		int DM_05 = 0;

		if (question5Index >= 0 && question5Index < question5_Options.length) {
			DM_05 = optionValues[question5Index];
		}

		System.out.println("DM_05 value: " + DM_05);

		// Do you have an accurate analysis of sales by Customer?
		WebElement question6 = driver.findElement(
				By.xpath("//div[text()='Do you have a process to take on a new customer?']//following::div[2]/div/div["
						+ (question6Index + 1) + "]"));
		question6.click();
		Thread.sleep(2000);
		
		Actions action = new Actions(driver);
		WebElement nextbutton = driver.findElement(nextButton);
		action.moveToElement(nextbutton).build().perform();
		Thread.sleep(2000);

		String[] question6_Options = { "none", "Poor processes", "Some Processes", "Good processes" };

		int DM_06 = 0;

		if (question6Index >= 0 && question6Index < question6_Options.length) {
			DM_06 = optionValues[question6Index];
		}

		System.out.println("DM_06 value: " + DM_06);

		// Do you have an accurate analysis of gross Margin by Customer?
		WebElement question7 = driver.findElement(By.xpath(
				"//div[text()='Do you have a process to utilize written terms & conditions?']//following::div[2]/div/div["
						+ (question7Index + 1) + "]"));
		question7.click();
		Thread.sleep(2000);
		
		String[] question7_Options = { "none", "Poor processes", "Some Processes", "Good processes" };

		int DM_07 = 0;

		if (question7Index >= 0 && question7Index < question7_Options.length) {
			DM_07 = optionValues[question7Index];
		}

		System.out.println("DM_07 value: " + DM_07);

		// How often do you review costs & look for savings?
		WebElement question8 = driver.findElement(By.xpath(
				"//div[text()='Do you regularly review and make provision for bad / doubtful debts?']//following::div[2]/div/div["
						+ (question8Index + 1) + "]"));
		question8.click();
		Thread.sleep(2000);

		String[] question8_Options = { "Never", "Annually", "Quarterly", "Monthly" };

		int DM_08 = 0;

		if (question8Index >= 0 && question8Index < question8_Options.length) {
			DM_08 = optionValues[question8Index];
		}

		System.out.println("DM_08 value: " + DM_08);

		// How often do you review costs & look for savings?
		WebElement question9 = driver
				.findElement(By.xpath("//div[contains(text(),'Financial questionnaire')]//following::div[2]/div/div["
						+ (question2Index + 1) + "]"));
		question9.click();
		Thread.sleep(2000);

		String[] question9_Options = { "Regularly", "Frequently", "Occassionally", "Never" };

		int DM_09 = 0;

		if (question9Index >= 0 && question9Index < question9_Options.length) {
			DM_09 = optionValues[question9Index];
		}

		System.out.println("DM_09 value: " + DM_09);

		debtorManagementChapter = DM_01 + DM_02 + DM_03 + DM_04 + DM_05 + DM_06 + DM_07 + DM_08 + DM_09;
		System.out.println(debtorManagementChapter);
		debtorManagementValue = (int) Math.round((double) debtorManagementChapter / 90 * 100);
		System.out.println(debtorManagementValue);

		nextbutton.click();
		Thread.sleep(2000);
	}

	public void creditorManagement(int question1Index, int question2Index, int question3Index, int question4Index,
			int question5Index, int question6Index) throws Exception {
		WebElement debtorManagement = driver.findElement(creditorManagementText);
		Assert.assertEquals(debtorManagement.getText(), "Creditor Management");

		// Do you have robust & effective terms & conditions of Sale including payment
		// terms, proven with customers
		WebElement question1 = driver.findElement(
				By.xpath("//div[text()='How long do you take to pay creditors?']/following::div[2]/div/div["
						+ (question1Index + 1) + "]"));
		question1.click();
		Thread.sleep(2000);

		String[] question1_Options = { "Over 60 days", "60 days", "45 Days", "30 Days" };

		int CM_01 = 0;

		if (question1Index >= 0 && question1Index < question1_Options.length) {
			CM_01 = optionValues[question1Index];
		}

		System.out.println("CM_01 value: " + CM_01);

		// Do you raise invoices as soon as the job / goods are delivered
		WebElement question2 = driver.findElement(
				By.xpath("//div[text()='Do you have a purchase authorisation process?']//following::div[2]/div/div["
						+ (question2Index + 1) + "]"));
		question2.click();
		Thread.sleep(2000);

		String[] question2_Options = { "none", "Poor processes", "Some Processes", "Good processes" };

		int CM_02 = 0;

		if (question2Index >= 0 && question2Index < question2_Options.length) {
			CM_02 = optionValues[question2Index];
		}

		System.out.println("CM_02 value: " + CM_02);

		// How long do Customers take to pay you?
		WebElement question3 = driver.findElement(By.xpath(
				"//div[text()='Do you have a documented payment authorisation process?']//following::div[2]/div/div["
						+ (question3Index + 1) + "]"));
		question3.click();
		Thread.sleep(2000);

		String[] question3_Options = { "none", "Poor processes", "Some Processes", "Good processes" };

		int CM_03 = 0;

		if (question3Index >= 0 && question3Index < question3_Options.length) {
			CM_03 = optionValues[question3Index];
		}

		System.out.println("CM_03 value: " + CM_03);

		// Do you have a defined process for debtor management?
		WebElement question4 = driver.findElement(By.xpath(
				"//div[text()='Does any one supplier represent a high% of your purchases?']//following::div[2]/div/div["
						+ (question4Index + 1) + "]"));
		question4.click();
		Thread.sleep(2000);

		String[] question4_Options = { ">40%", "<40%", "< 20%", "No" };

		int CM_04 = 0;

		if (question4Index >= 0 && question4Index < question4_Options.length) {
			CM_04 = optionValues[question4Index];
		}

		System.out.println("CM_04 value: " + CM_04);

//		Actions action = new Actions(driver);
//		WebElement nextbutton = driver.findElement(nextButton);
//		action.moveToElement(nextbutton).build();

		// Does any one client represent a high% of your business?
		WebElement question5 = driver.findElement(By.xpath(
				"//div[text()='For larger creditors do you agree terms in advance of doing business?']//following::div[2]/div/div["
						+ (question5Index + 1) + "]"));
		question5.click();
		Thread.sleep(2000);

		String[] question5_Options = { "no", "sometimes", "Verbal", "in writing" };

		int CM_05 = 0;

		if (question5Index >= 0 && question5Index < question5_Options.length) {
			CM_05 = optionValues[question5Index];
		}

		System.out.println("CM_05 value: " + CM_05);

		// Do you have an accurate analysis of sales by Customer?
		WebElement question6 = driver.findElement(
				By.xpath("//div[text()='Do you hold back payment waiting for money in?']//following::div[2]/div/div["
						+ (question6Index + 1) + "]"));
		question6.click();
		Thread.sleep(2000);

		String[] question6_Options = { "Every payment", "Frequently", "Occassionally", "Never" };

		int CM_06 = 0;

		if (question6Index >= 0 && question6Index < question6_Options.length) {
			CM_06 = optionValues[question6Index];
		}

		System.out.println("CM_06 value: " + CM_06);

		creditorManagementChapter = CM_01 + CM_02 + CM_03 + CM_04 + CM_05 + CM_06;
		System.out.println(creditorManagementChapter);
		creditorManagementValue = (int) Math.round((double) creditorManagementChapter / 60 * 100);
		System.out.println(creditorManagementValue);

		WebElement nextbutton = driver.findElement(nextButton);
		nextbutton.click();
		Thread.sleep(2000);
	}

	public void payroll(int question1Index, int question2Index, int question3Index, int question4Index,
			int question5Index) throws Exception {
		WebElement payroll = driver.findElement(payrollText);
		Assert.assertEquals(payroll.getText(), "Payroll / HR /Staff Management");

		// Do you have processes to ensure that employees are completing tasks to agreed
		// times?
		WebElement question1 = driver.findElement(By.xpath(
				"//div[text()='Do you have processes to ensure that employees are completing tasks to agreed times?']//following::div[2]/div/div["
						+ (question1Index + 1) + "]"));
		question1.click();
		Thread.sleep(2000);

		String[] question1_Options = { "none", "Poor processes", "Some Processes", "Good processes" };

		int PR_01 = 0;

		if (question1Index >= 0 && question1Index < question1_Options.length) {
			PR_01 = optionValues[question1Index];
		}

		System.out.println("PR_01 value: " + PR_01);

		// Do you have processes to monitor productivity by employees? E.g. lost time /
		// travel time
		WebElement question2 = driver.findElement(By.xpath(
				"//div[text()='Do you have processes to monitor productivity by employees? E.g. lost time / travel time']//following::div[2]/div/div["
						+ (question2Index + 1) + "]"));
		question2.click();
		Thread.sleep(2000);

		String[] question2_Options = { "none", "Poor processes", "Some Processes", "Good processes" };

		int PR_02 = 0;

		if (question2Index >= 0 && question2Index < question2_Options.length) {
			PR_02 = optionValues[question2Index];
		}

		System.out.println("PR_02 value: " + PR_02);

		// Do you have processes to monitor expenses use of vehicles by employees?
		WebElement question3 = driver.findElement(By.xpath(
				"//div[contains(text(),'Do you have processes to monitor expenses use of vehicles by employees?')]//following::div[2]/div/div["
						+ (question3Index + 1) + "]"));
		question3.click();
		Thread.sleep(2000);

		String[] question3_Options = { "none", "Poor processes", "Some Processes", "Good processes" };

		int PR_03 = 0;

		if (question3Index >= 0 && question3Index < question3_Options.length) {
			PR_03 = optionValues[question3Index];
		}

		System.out.println("PR_03 value: " + PR_03);

		// Do Payroll control, Paye & NI, pension accounts agree with what is due?
		WebElement question4 = driver.findElement(By.xpath(
				"//div[contains(text(),'Do Payroll control, Paye & NI, pension accounts agree with what is due?')]//following::div[2]/div/div["
						+ (question4Index + 1) + "]"));
		question4.click();
		Thread.sleep(2000);

		String[] question4_Options = { "never", "Fully agreed annually", "Fully Agreed quarterly",
				"Fully agreed monthly" };

		int PR_04 = 0;

		if (question4Index >= 0 && question4Index < question4_Options.length) {
			PR_04 = optionValues[question4Index];
		}

		System.out.println("PR_04 value: " + PR_04);

//		Actions action = new Actions(driver);
//		WebElement nextbutton = driver.findElement(nextButton);
//		action.moveToElement(nextbutton).build();
		// .perform();

		// Do you always pay employees on the agreed date?

		WebElement question5 = driver.findElement(By.xpath(
				"//div[contains(text(),'Do you always pay employees on the agreed date?')]//following::div[2]/div/div["
						+ (question5Index + 1) + "]"));
		question5.click();
		Thread.sleep(2000);

		String[] question5_Options = { "rarely", "occassionally", "Usually", "Yes" };

		int PR_05 = 0;

		if (question5Index >= 0 && question5Index < question5_Options.length) {
			PR_05 = optionValues[question5Index];
		}

		System.out.println("PR_05 value: " + PR_05);

		payrollChapter = PR_01 + PR_02 + PR_03 + PR_04 + PR_05;
		System.out.println(payrollChapter);
		payrollValue = (int) Math.round((double) payrollChapter / 50 * 100);
		System.out.println(payrollValue);

		WebElement nextbutton = driver.findElement(nextButton);
		nextbutton.click();
		Thread.sleep(2000);
	}

	public void stockManagement(int question1Index, int question2Index, int question3Index, int question4Index,
			int question5Index) throws Exception {
		WebElement stockManagement = driver.findElement(stockManagementText);
		Assert.assertEquals(stockManagement.getText(), "Stock Management");

		// Do you have processes to manage stock holding levels?
		WebElement question1 = driver.findElement(By.xpath(
				"//div[text()='Do you have processes to manage stock holding levels?']//following::div[2]/div/div["
						+ (question1Index + 1) + "]"));
		question1.click();
		Thread.sleep(2000);

		String[] question1_Options = { "none", "Poor processes", "Some Processes", "Good processes" };

		int SM_01 = 0;

		if (question1Index >= 0 && question1Index < question1_Options.length) {
			SM_01 = optionValues[question1Index];
		}

		System.out.println("SM_01 value: " + SM_01);

		// Do you have a stock-purchase authorisation process?
		WebElement question2 = driver.findElement(By
				.xpath("//div[text()='Do you have a stock-purchase authorisation process?']//following::div[2]/div/div["
						+ (question2Index + 1) + "]"));
		question2.click();
		Thread.sleep(2000);

		String[] question2_Options = { "none", "Poor processes", "Some Processes", "Good processes" };

		int SM_02 = 0;

		if (question2Index >= 0 && question2Index < question2_Options.length) {
			SM_02 = optionValues[question2Index];
		}

		System.out.println("SM_02 value: " + SM_02);

		// Do you have processes to monitor expenses use of vehicles by employees?
		WebElement question3 = driver.findElement(By.xpath(
				"//div[text()='Does your stock list / valuation agree with the Balance sheet?']//following::div[2]/div/div["
						+ (question3Index + 1) + "]"));
		question3.click();
		Thread.sleep(2000);

		String[] question3_Options = { "never", "Fully agreed annually", "Fully Agreed quarterly",
				"Fully agreed monthly" };

		int SM_03 = 0;

		if (question3Index >= 0 && question3Index < question3_Options.length) {
			SM_03 = optionValues[question3Index];
		}

		System.out.println("SM_03 value: " + SM_03);

		// Do Payroll control, Paye & NI, pension accounts agree with what is due?
		WebElement question4 = driver.findElement(By.xpath(
				"//div[text()='Do you regularly review and make provision for slow moving / obsolete stock?']//following::div[2]/div/div["
						+ (question4Index + 1) + "]"));
		question4.click();
		Thread.sleep(2000);

		String[] question4_Options = { "Never", "Never", "Quarterly", "Monthly" };

		int SM_04 = 0;

		if (question4Index >= 0 && question4Index < question4_Options.length) {
			SM_04 = optionValues[question4Index];
		}

		System.out.println("SM_04 value: " + SM_04);

		Actions action = new Actions(driver);
		WebElement nextbutton = driver.findElement(nextButton);
		action.moveToElement(nextbutton).build();
		// .perform();

		// Do you always pay employees on the agreed date?

		WebElement question5 = driver.findElement(By.xpath(
				"//div[text()='Do you apply the principles of Stock-Turn in your business?']//following::div[2]/div/div["
						+ (question5Index + 1) + "]"));
		question5.click();
		Thread.sleep(2000);

		String[] question5_Options = { "Never", "Occasionally", "Frequently", "Consistently" };

		int SM_05 = 0;

		if (question5Index >= 0 && question5Index < question5_Options.length) {
			SM_05 = optionValues[question5Index];
		}

		System.out.println("SM_05 value: " + SM_05);

		stockManagementChapter = SM_01 + SM_02 + SM_03 + SM_04 + SM_05;
		System.out.println(stockManagementChapter);
		stockManagementValue = (int) Math.round((double) stockManagementChapter / 50 * 100);
		System.out.println(stockManagementValue);

		nextbutton.click();
		Thread.sleep(2000);
	}

	public void hmrc(int question1Index, int question2Index, int question3Index) throws Exception {
		WebElement hmrc = driver.findElement(hmrcText);
		Assert.assertEquals(hmrc.getText(), "HMRC - Payments");

		// Are Paye payments made on time
		WebElement question1 = driver
				.findElement(By.xpath("//div[text()='Are Paye payments made on time']//following::div[2]/div/div["
						+ (question1Index + 1) + "]"));
		question1.click();
		Thread.sleep(2000);

		String[] question1_Options = { "Need payment plan", "upto 30 days late", "A few days late", "On time" };

		int HMRC_01 = 0;

		if (question1Index >= 0 && question1Index < question1_Options.length) {
			HMRC_01 = optionValues[question1Index];
		}

		System.out.println("HMRC_01 value: " + HMRC_01);

		// Are Vat payments made on time
		WebElement question2 = driver
				.findElement(By.xpath("//div[text()='Are Vat payments made on time']//following::div[2]/div/div["
						+ (question2Index + 1) + "]"));
		question2.click();
		Thread.sleep(2000);

		String[] question2_Options = { "Need payment plan", "upto 30 days late", "A few days late", "On time" };

		int HMRC_02 = 0;

		if (question2Index >= 0 && question2Index < question2_Options.length) {
			HMRC_02 = optionValues[question2Index];
		}

		System.out.println("HMRC_02 value: " + HMRC_02);

		// Are Corporation tax payments made on time
		WebElement question3 = driver.findElement(
				By.xpath("//div[text()='Are Corporation tax payments made on time']//following::div[2]/div/div["
						+ (question3Index + 1) + "]"));
		question3.click();
		Thread.sleep(2000);

		String[] question3_Options = { "Need payment plan", "upto 30 days late", "A few days late", "On time" };

		int HMRC_03 = 0;

		if (question3Index >= 0 && question3Index < question3_Options.length) {
			HMRC_03 = optionValues[question3Index];
		}

		System.out.println("HMRC_03 value: " + HMRC_03);

		hmrcChapter = HMRC_01 + HMRC_02 + HMRC_03;
		System.out.println(hmrcChapter);
		hmrcValue = (int) Math.round((double) hmrcChapter / 30 * 100);
		System.out.println(hmrcValue);

		WebElement nextbutton = driver.findElement(nextButton);
		nextbutton.click();
		Thread.sleep(2000);
	}

	public void fixedAssets(int question1Index, int question2Index, int question3Index, int question4Index,
			int question5Index, int question6Index, int question7Index) throws Exception {
		WebElement fixedAssets = driver.findElement(fixedAssetsText);
		Assert.assertEquals(fixedAssets.getText(), "Fixed Assets / Capital Expenditure");

		// Does your Fixed asset register agree with the Balance Sheet?
		WebElement question1 = driver.findElement(By.xpath(
				"//div[text()='Does your Fixed asset register agree with the Balance Sheet?']//following::div[2]/div/div["
						+ (question1Index + 1) + "]"));
		question1.click();
		Thread.sleep(2000);

		String[] question1_Options = { "Not Applicable", "Fully agreed annually", "Fully Agreed quarterly",
				"Fully agreed monthly" };

		int FA_01 = 0;

		if (question1Index >= 0 && question1Index < question1_Options.length) {
			FA_01 = optionValues[question1Index];
		}

		System.out.println("FA_01 value: " + FA_01);

		// Do you ensure depreciation rates are in line with useful life?
		WebElement question2 = driver.findElement(By.xpath(
				"//div[contains(text(),'Do you ensure depreciation rates are in line with useful life?')]//following::div[2]/div/div["
						+ (question2Index + 1) + "]"));
		question2.click();
		Thread.sleep(2000);

		String[] question2_Options = { "no", "bigger items", "as recommended by accountant", "Yes" };

		int FA_02 = 0;

		if (question2Index >= 0 && question2Index < question2_Options.length) {
			FA_02 = optionValues[question2Index];
		}

		System.out.println("FA_02 value: " + FA_02);

		// Do you make sure that all disposals are booked as they occur and any
		// loss/gain recorded?
		WebElement question3 = driver.findElement(By.xpath(
				"//div[contains(text(),'Do you make sure that all disposals are booked as they occur and any loss/gain recorded?')]//following::div[2]/div/div["
						+ (question3Index + 1) + "]"));
		question3.click();
		Thread.sleep(2000);

		String[] question3_Options = { "Never", "Annually", "Quarterly", "Quarterly" };

		int FA_03 = 0;

		if (question3Index >= 0 && question3Index < question3_Options.length) {
			FA_03 = optionValues[question3Index];
		}

		System.out.println("FA_03 value: " + FA_03);

		// Do you have a capital expenditure authorisation process?
		WebElement question4 = driver.findElement(By.xpath(
				"//div[contains(text(),'Do you have a capital expenditure authorisation process?')]//following::div[2]/div/div["
						+ (question4Index + 1) + "]"));
		question4.click();
		Thread.sleep(2000);

		String[] question4_Options = { "none", "Poor processes", "Some Processes", "Good processes" };

		int FA_04 = 0;

		if (question4Index >= 0 && question4Index < question4_Options.length) {
			FA_04 = optionValues[question4Index];
		}

		System.out.println("FA_04 value: " + FA_04);

		Actions action = new Actions(driver);
		WebElement nextbutton = driver.findElement(nextButton);
		action.moveToElement(nextbutton).build();
		// .perform();

		// How robust is your Capital Expenditure Budget for the year?
		WebElement question5 = driver.findElement(By.xpath(
				"//div[contains(text(),'How robust is your Capital Expenditure Budget for the year?')]//following::div[2]/div/div["
						+ (question5Index + 1) + "]"));
		question5.click();
		Thread.sleep(2000);

		String[] question5_Options = { "None", "Poor", "Adequate", "Good" };

		int FA_05 = 0;

		if (question5Index >= 0 && question5Index < question5_Options.length) {
			FA_05 = optionValues[question5Index];
		}

		System.out.println("FA_05 value: " + FA_05);

		// Do you have a process to review Capital Expenditure to establish payback?
		WebElement question6 = driver.findElement(By.xpath(
				"//div[contains(text(),'Do you have a process to review Capital Expenditure to establish payback?')]//following::div[2]/div/div["
						+ (question6Index + 1) + "]"));
		question6.click();
		Thread.sleep(2000);

		String[] question6_Options = { "none", "Poor processes", "Some Processes", "Good processes" };

		int FA_06 = 0;

		if (question6Index >= 0 && question6Index < question6_Options.length) {
			FA_06 = optionValues[question6Index];
		}

		System.out.println("FA_06 value: " + FA_06);

		// Do you regularly review the impact on cashflow of new Capital Expenditure?
		WebElement question7 = driver.findElement(By.xpath(
				"//div[contains(text(),'Do you regularly review the impact on cashflow of new Capital Expenditure?')]//following::div[2]/div/div["
						+ (question7Index + 1) + "]"));
		question7.click();
		Thread.sleep(2000);

		String[] question7_Options = { "Never", "Annually", "Quarterly", "Monthly" };

		int FA_07 = 0;

		if (question7Index >= 0 && question7Index < question7_Options.length) {
			FA_07 = optionValues[question7Index];
		}

		System.out.println("FA_07 value: " + FA_07);

		fixedAssetsChapter = FA_01 + FA_02 + FA_03 + FA_04 + FA_05 + FA_06 + FA_07;
		System.out.println(fixedAssetsChapter);
		fixedAssetsValue = (int) Math.round((double) fixedAssetsChapter / 70 * 100);
		System.out.println(fixedAssetsValue);

		nextbutton.click();
		Thread.sleep(2000);
	}

	public void finance(int question1Index, int question2Index, int question3Index) throws Exception {
		WebElement finance = driver.findElement(financeText);
		Assert.assertEquals(finance.getText(), "Finance");

		// How do you rate the usefulness of your Financial Information?
		WebElement question1 = driver.findElement(By.xpath(
				"//div[text()='How do you rate the usefulness of your Financial Information?']//following::div[2]/div/div["
						+ (question1Index + 1) + "]"));
		question1.click();
		Thread.sleep(2000);

		String[] question1_Options = { "Need payment plan", "upto 30 days late", "A few days late", "On time" };

		int FI_01 = 0;

		if (question1Index >= 0 && question1Index < question1_Options.length) {
			FI_01 = optionValues[question1Index];
		}

		System.out.println("FI_01 value: " + FI_01);

		// Is the availability of Finance for growth holding you back?
		WebElement question2 = driver.findElement(By.xpath(
				"//div[text()='Is the availability of Finance for growth holding you back?']//following::div[2]/div/div["
						+ (question2Index + 1) + "]"));
		question2.click();
		Thread.sleep(2000);

		String[] question2_Options = { "Need payment plan", "upto 30 days late", "A few days late", "On time" };

		int FI_02 = 0;

		if (question2Index >= 0 && question2Index < question2_Options.length) {
			FI_02 = optionValues[question2Index];
		}

		System.out.println("FI_02 value: " + FI_02);

		// Do you use someone as a sounding board for new ideas / issues in your
		// business?
		WebElement question3 = driver.findElement(By.xpath(
				"//div[text()='Do you use someone as a sounding board for new ideas / issues in your business?']//following::div[2]/div/div["
						+ (question3Index + 1) + "]"));
		question3.click();
		Thread.sleep(2000);

		String[] question3_Options = { "Need payment plan", "upto 30 days late", "A few days late", "On time" };

		int FI_03 = 0;

		if (question3Index >= 0 && question3Index < question3_Options.length) {
			FI_03 = optionValues[question3Index];
		}

		System.out.println("FI_03 value: " + FI_03);

		financeChapter = FI_01 + FI_02 + FI_03;
		System.out.println(financeChapter);
		financeValue = (int) Math.round((double) financeChapter / 30 * 100);
		System.out.println(financeValue);

		WebDriverWait wait = new WebDriverWait(driver, Duration.ofSeconds(100));
		WebElement submitbutton = wait.until(ExpectedConditions.elementToBeClickable(submitButton));

		submitbutton.click();
//		Actions action = new Actions(driver);
//		action.moveToElement(submitbutton).doubleClick().click();
		Thread.sleep(3000);

	}

	public void businessOverview() {
		int businessOverview = managementInfromationChapter + forecastingChapter + debtorManagementChapter
				+ creditorManagementChapter + payrollChapter + stockManagementChapter + hmrcChapter + fixedAssetsChapter
				+ financeChapter;

		WebDriverWait wait = new WebDriverWait(driver, Duration.ofSeconds(30));
		WebElement mi_score = wait.until(ExpectedConditions.presenceOfElementLocated(managementInformationScore));
		String miScore = mi_score.getText();
		String miScoreValue = miScore.replace("%", "").trim();// Remove the percentage sign
		int miscore = Integer.valueOf(miScoreValue);
		Assert.assertEquals(miscore, managementInformationValue);

		String foreScore = driver.findElement(forecastingScore).getText();
		String foreScoreValue = foreScore.replace("%", ""); // Remove the percentage sign
		int forescore = Integer.valueOf(foreScoreValue);
		Assert.assertEquals(forescore, forecastingValue);

		String dmScore = driver.findElement(debtorManagementScore).getText();
		String dmScoreValue = dmScore.replace("%", ""); // Remove the percentage sign
		int dmscore = Integer.valueOf(dmScoreValue);
		Assert.assertEquals(dmscore, debtorManagementValue);

		String cmScore = driver.findElement(creditorManagementScore).getText();
		String cmScoreValue = cmScore.replace("%", ""); // Remove the percentage sign
		int cmscore = Integer.valueOf(cmScoreValue);
		Assert.assertEquals(cmscore, creditorManagementValue);

		String prScore = driver.findElement(payrollScore).getText();
		String prScoreValue = prScore.replace("%", ""); // Remove the percentage sign
		int prscore = Integer.valueOf(prScoreValue);
		Assert.assertEquals(prscore, payrollValue);

		String smScore = driver.findElement(stockManagementScore).getText();
		String smScoreValue = smScore.replace("%", ""); // Remove the percentage sign
		int smscore = Integer.valueOf(smScoreValue);
		Assert.assertEquals(smscore, stockManagementValue);

		String hmScore = driver.findElement(hmrcScore).getText();
		String hmScoreValue = hmScore.replace("%", ""); // Remove the percentage sign
		int hmscore = Integer.valueOf(hmScoreValue);
		Assert.assertEquals(hmscore, hmrcValue);

		Actions action = new Actions(driver);
		WebElement nextbutton = driver.findElement(nextButton);
		action.moveToElement(nextbutton).build();

		String faScore = driver.findElement(fixedAssetsScore).getText();
		String faScoreValue = faScore.replace("%", ""); // Remove the percentage sign
		int fascore = Integer.valueOf(faScoreValue);
		Assert.assertEquals(fascore, fixedAssetsValue);

		String fiScore = driver.findElement(financeScore).getText();
		String fiScoreValue = fiScore.replace("%", ""); // Remove the percentage sign
		int fiscore = Integer.valueOf(fiScoreValue);
		Assert.assertEquals(fiscore, financeValue);

		int overallPercentage = (int) Math.round((double) businessOverview / 500 * 100);
		System.out.println(overallPercentage);

		String overallpercentage = driver.findElement(overallPercentageScore).getText();
		String overallpercentageValue = overallpercentage.replace("%", ""); // Remove the percentage sign
		int overallpercentagescore = Integer.valueOf(overallpercentageValue);
		Assert.assertEquals(overallpercentagescore, overallpercentageValue);

	}

}
