package com.magnifyb.webpages;

import java.time.Duration;

import org.openqa.selenium.By;
import org.openqa.selenium.JavascriptExecutor;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.interactions.Actions;
import org.openqa.selenium.support.ui.ExpectedConditions;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.testng.Assert;
import org.testng.annotations.Test;

import com.magnifyb.pageobjects.FinanceQuestionsPageObjects;
import com.magnifyb.utils.Excel;

public class FinanceQuestions extends FinanceQuestionsPageObjects {
public static String actual, expected;
	
	public static String filepath = System.getProperty("user.dir") + "\\src\\test\\java\\com\\magnifyb\\testdata\\testdata.xlsx";
	public static String sheetname = "Signin";
	 Excel excel = new Excel();
	
	@Test
	public void financequestions() throws Throwable {
		Excel.readExcel(filepath, sheetname);
		

		// navigates to application
		launchBrowser(Excel.testDataFromExcel("BroswerType"), Excel.testDataFromExcel("Url"));
		
		driver.manage().timeouts().implicitlyWait(Duration.ofSeconds(30));
		
		Thread.sleep(5000);
		
		// Enter email address
		WebElement emailAddress = new WebDriverWait(driver, Duration.ofSeconds(30))
				.until(ExpectedConditions.visibilityOfElementLocated(By.xpath(emailIDTextField)));
		emailAddress.sendKeys(Excel.testDataFromExcel("Email Address"));
		
		//Click on sign up button
		WebElement signupButton = new WebDriverWait(driver, Duration.ofSeconds(30))
				.until(ExpectedConditions.visibilityOfElementLocated(By.xpath(signup)));
		signupButton.click();
		
		//Validate Your email already exists. Please login pop up text
		WebElement youremailalreadyexistsPleaselogin = new WebDriverWait(driver, Duration.ofSeconds(30))
				.until(ExpectedConditions.visibilityOfElementLocated(By.xpath(YouremailPleaselogin)));
		actual = youremailalreadyexistsPleaselogin.getText();
		expected = "Your email already exists. Please login.";
		Assert.assertEquals(actual, expected);
		
		//Click on ok button
		WebElement OkButton = new WebDriverWait(driver, Duration.ofSeconds(30))
				.until(ExpectedConditions.visibilityOfElementLocated(By.xpath(okButton)));
		OkButton.click();
		Thread.sleep(3000);
		
		//Validate login text
		WebElement Login = new WebDriverWait(driver, Duration.ofSeconds(30))
				.until(ExpectedConditions.visibilityOfElementLocated(By.xpath(Logintext)));
		actual = Login.getText();
		expected = "LOGIN";
		Assert.assertEquals(actual, expected);	
		
				
		//Enter Password
		WebElement passwordField = new WebDriverWait(driver, Duration.ofSeconds(30))
				.until(ExpectedConditions.visibilityOfElementLocated(By.xpath(passwordTextField)));
		passwordField.sendKeys(Excel.testDataFromExcel("Password"));

				
		//Click on sign in button
		WebElement signInButton = new WebDriverWait(driver, Duration.ofSeconds(30))
		.until(ExpectedConditions.visibilityOfElementLocated(By.xpath(signinButton)));
		signInButton.click();
		
		
		//Validate my company dashboard
		WebElement Mycompanydashboard = new WebDriverWait(driver, Duration.ofSeconds(30))
				.until(ExpectedConditions.visibilityOfElementLocated(By.xpath(MyCompanyDashboard)));
		String mycompanydashboard = Mycompanydashboard.getText();
		Assert.assertEquals(mycompanydashboard, Excel.testDataFromExcel("My Company Dashboard"));
		
		Thread.sleep(5000);
		
		Actions action = new Actions(driver);
		JavascriptExecutor js = (JavascriptExecutor) driver;
	

		//Click on questionnaire drop down button
		WebElement questionnaireDropDown = new WebDriverWait(driver, Duration.ofSeconds(30))
				.until(ExpectedConditions.visibilityOfElementLocated(By.xpath(questionnaireDropdown)));
		action.moveToElement(questionnaireDropDown).click().perform();
		Thread.sleep(2000);
		
		// Scrolling down the page till the business Areas is found	
		WebElement movebusinessAreas = new WebDriverWait(driver, Duration.ofSeconds(30))
				.until(ExpectedConditions.elementToBeClickable(By.xpath(moveBusinessAreas)));	
		  js.executeScript("arguments[0].scrollIntoView();", movebusinessAreas);
        
        
        //click on Business Areas
        WebElement businessAreas = new WebDriverWait(driver, Duration.ofSeconds(30))
				.until(ExpectedConditions.elementToBeClickable(By.xpath(businessareas)));	
		action.moveToElement(businessAreas).doubleClick().perform();
		Thread.sleep(5000);
		
		//Validate finance text
		WebElement Finance = new WebDriverWait(driver, Duration.ofSeconds(30))
				.until(ExpectedConditions.visibilityOfElementLocated(By.xpath(finance)));
		  js.executeScript("arguments[0].scrollIntoView();", Finance);
		String financeText = Finance.getText();
		Assert.assertEquals(financeText, Excel.testDataFromExcel("Finance"));
		
		
		
	}
	

}
