package com.magnifyb.webpages;

import java.time.Duration;

import org.openqa.selenium.By;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.support.ui.ExpectedConditions;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.testng.Assert;
import org.testng.annotations.Test;

@Test
public class Login {

	private static WebDriver driver;
	// sign in
	By loginButton = By.xpath("//div[text()='Login']");
	By emailIDTextField = By.xpath("//input[@name='username']");
	By passwordTextField = By.xpath("//input[@name='password']");
	By signinButton = By.xpath("//div[text()='Sign in']");
	By MyCompanyDashboard = By.xpath("//div[contains(text(), 'My Company Dashboard')]");

	public Login(WebDriver driver) {
		Login.driver = driver;
	}

	public void loginApplication() throws Exception {
		WebDriverWait wait = new WebDriverWait(driver, Duration.ofSeconds(100));

		WebElement loginbutton = wait.until(ExpectedConditions.elementToBeClickable(loginButton));
//		  WebElement loginbutton = driver.findElement(loginButton);
//	    ((JavascriptExecutor) driver).executeScript("arguments[0].scrollIntoView(true);", loginButton);

		loginbutton.click();

		WebElement un = driver.findElement(emailIDTextField);
		un.sendKeys("durgaradha7@gmail.com");
//		un.sendKeys("ramanjeneyulu.j@machint.com");

		WebElement pw = driver.findElement(passwordTextField);
		pw.sendKeys("Machint@123");

		WebElement signinbutton = driver.findElement(signinButton);
		signinbutton.click();

		Thread.sleep(30000);

		WebElement dashboard = driver.findElement(MyCompanyDashboard);
		String dashboardText = dashboard.getText();
		Assert.assertEquals(dashboardText, "My Company Dashboard");
	}

}
